module RulingTimer
  class Engine < ::Rails::Engine
    initializer "ruling_timer" do
      begin
        OrbitApp.registration "RulingTimer", :type => "OrbitMemberModule" do
          module_label "ruling_timer.ruling_timer"
          base_url File.expand_path File.dirname(__FILE__)
          authorizable
          side_bar do
            head_label_i18n 'ruling_timer.ruling_timer', icon_class: "icons-clock"
            available_for "users"
            active_for_controllers (['admin/ruling_timers'])
            head_link_path "admin_ruling_timers_path"

            context_link 'restful_actions.timer_management',
                                  :link_path=>"timer_management_admin_ruling_timers_path" ,
                                  :priority=>1,
                                  :active_for_action=>{'admin/ruling_timers'=>'timer_management'},
                                  :available_for => 'managers'
            context_link 'restful_actions.task_management',
                                  :link_path=>"task_management_admin_ruling_timers_path" ,
                                  :priority=>2,
                                  :active_for_action=>{'admin/ruling_timers'=>'task_management'},
                                  :available_for => 'managers'
          end
        end
      rescue => e
        OrbitApp.registration "RulingTimer", :type => "ModuleApp" do
          module_label "ruling_timer.ruling_timer"
          base_url File.expand_path File.dirname(__FILE__)
          authorizable
          side_bar do
            head_label_i18n 'ruling_timer.ruling_timer', icon_class: "icons-clock"
            available_for "users"
            active_for_controllers (['admin/ruling_timers'])
            head_link_path "admin_ruling_timers_path"

            context_link 'restful_actions.timer_management',
                                  :link_path=>"timer_management_admin_ruling_timers_path" ,
                                  :priority=>1,
                                  :active_for_action=>{'admin/ruling_timers'=>'timer_management'},
                                  :available_for => 'managers'
            context_link 'restful_actions.task_management',
                                  :link_path=>"task_management_admin_ruling_timers_path" ,
                                  :priority=>2,
                                  :active_for_action=>{'admin/ruling_timers'=>'task_management'},
                                  :available_for => 'managers'
          end
        end
      end
    end
  end
end
